//
//   Programming by Andree Heyroth, Syncro-Concept
//
//   http://www.syncro-concept.de
//
//   Please add this unit to your desired project and compile as usual.
//   The Form can be initialized automatically (project default) or 
//   using Application.Createform ...
//
//   Improvements are appreciated ...
//
//   ---------------------------------------------------------------------------
//
unit Calculator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus
{$ifdef HaushaltWin}
  ,PropForm
{$endif}
;

type
{$ifdef HaushaltWin}
  TFCalculator = class(TFPropForm)
{$else}
  TFCalculator = class(TForm)
{$endif}
    btnFour: TButton;
    btnFive: TButton;
    btnSix: TButton;
    btnSeven: TButton;
    btnEight: TButton;
    btnNine: TButton;
    btnZero: TButton;
    btnOne: TButton;
    btnTwo: TButton;
    btnThree: TButton;
    btnPlus: TButton;
    btnMinus: TButton;
    btnMult: TButton;
    btnDiv: TButton;
    btnResult: TButton;
    btnClear: TButton;
    btnDot: TButton;
    edtExpression: TEdit;
    edtResult: TEdit;
    btnBack: TButton;
    tbAlphaBlend: TTrackBar;
    btnUp: TButton;
    cmbCalcValues: TComboBox;
    btnUpLst: TButton;
    popupMenuTerme: TPopupMenu;
    itmTermLoeschen: TMenuItem;
    btnBracketsOpen: TButton;
    btnBracketsClose: TButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnBracketsCloseClick(Sender: TObject);
    procedure btnBracketsOpenClick(Sender: TObject);
    procedure itmTermLoeschenClick(Sender: TObject);
    procedure btnUpLstClick(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure tbAlphaBlendChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnResultClick(Sender: TObject);
    procedure btnDivClick(Sender: TObject);
    procedure btnMultClick(Sender: TObject);
    procedure btnMinusClick(Sender: TObject);
    procedure btnPlusClick(Sender: TObject);
    procedure btnDotClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnZeroClick(Sender: TObject);
    procedure btnNineClick(Sender: TObject);
    procedure btnEightClick(Sender: TObject);
    procedure btnSevenClick(Sender: TObject);
    procedure btnSixClick(Sender: TObject);
    procedure btnFiveClick(Sender: TObject);
    procedure btnFourClick(Sender: TObject);
    procedure btnThreeClick(Sender: TObject);
    procedure btnTwoClick(Sender: TObject);
    procedure btnOneClick(Sender: TObject);
  private
    procedure ProcessClick(cChar: char);
    function ParseAndCalculate(cExpr: string): double;
    function GetFloat(cValue: string): double;
    function GetPos(nStart: integer; cStr: string): integer;
    procedure ClearCalculator;
    procedure AddCalcValue(cInputValue: string);
    procedure DeleteTrailingOperatos(var cExpr: string);
    function CheckBrackets(cExpr: string): boolean;
    procedure AddBracket(cBracket: string);
    function GetCloseCnt(nStart: integer; cExpr: string): integer;
    function GetOpenCnt(nStart: integer; cExpr: string): integer;
    function CalculateExpression: double;
    function CalculateTerm: double;
    function CalculateFactor: double;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  protected
    procedure CreateParams(var Params: TCreateParams); override;  public
  end;

type
  TCalcValue = Record
    cOperator,
    cSign    : char;
    dValue   : double;
  end;
  TCalcValueArray = array of TCalcValue;
  
var
  FCalculator    : TFCalculator;
  gInputValue    : string;           // enthlt immer die aktuelle zahl mit operator und evtl. vorzeichen
  gExpression    : string;           // zu parsender und zu berechnender ausdruck
  gi             : integer;          // aktuelle position in gExpression

const 
  C_1            = '1';
  C_2            = '2';
  C_3            = '3';
  C_4            = '4';
  C_5            = '5';
  C_6            = '6';
  C_7            = '7';
  C_8            = '8';
  C_9            = '9';
  C_0            = '0';
  C_MINUS        = '-';
  C_PLUS         = '+';
  C_MULT         = '*';
  C_DIV          = '/';
  C_DOT          = ',';
  C_CLEAR        = 'C';
  C_RESULT       = '=';
  C_BACK         = '<';
  C_LEFTBRACKET  = '(';
  C_RIGHTBRACKET = ')';
  C_DELIM        = '   |   ';
  
implementation

{$R *.dfm}

{$ifdef HaushaltWin}
uses
  haushaltutility;
{$endif}

procedure TFCalculator.btnBracketsOpenClick(Sender: TObject);
begin
  ProcessClick (C_LEFTBRACKET);
end;

procedure TFCalculator.btnBracketsCloseClick(Sender: TObject);
begin
  ProcessClick (C_RIGHTBRACKET);
end;

procedure TFCalculator.btnOneClick(Sender: TObject);
begin
  ProcessClick (C_1);
end;

procedure TFCalculator.btnTwoClick(Sender: TObject);
begin
  ProcessClick (C_2);
end;

procedure TFCalculator.btnThreeClick(Sender: TObject);
begin
  ProcessClick (C_3);
end;

procedure TFCalculator.btnFourClick(Sender: TObject);
begin
  ProcessClick (C_4);
end;

procedure TFCalculator.btnFiveClick(Sender: TObject);
begin
  ProcessClick (C_5);
end;

procedure TFCalculator.btnSixClick(Sender: TObject);
begin
  ProcessClick (C_6);
end;

procedure TFCalculator.btnSevenClick(Sender: TObject);
begin
  ProcessClick (C_7);
end;

procedure TFCalculator.btnEightClick(Sender: TObject);
begin
  ProcessClick (C_8);
end;

procedure TFCalculator.btnNineClick(Sender: TObject);
begin
  ProcessClick (C_9);
end;

procedure TFCalculator.btnZeroClick(Sender: TObject);
begin
  ProcessClick (C_0);
end;

procedure TFCalculator.btnClearClick(Sender: TObject);
begin
  ProcessClick (C_CLEAR);
end;

procedure TFCalculator.btnDotClick(Sender: TObject);
begin
  ProcessClick (C_DOT);
end;

procedure TFCalculator.btnPlusClick(Sender: TObject);
begin
  ProcessClick (C_PLUS);
end;

procedure TFCalculator.btnMinusClick(Sender: TObject);
begin
  ProcessClick (C_MINUS);
end;

procedure TFCalculator.btnMultClick(Sender: TObject);
begin
  ProcessClick (C_MULT);
end;

procedure TFCalculator.btnDivClick(Sender: TObject);
begin
  ProcessClick (C_DIV);
end;

procedure TFCalculator.btnResultClick(Sender: TObject);
begin
  ProcessClick (C_RESULT);
end;

procedure TFCalculator.btnBackClick(Sender: TObject);
begin
  ProcessClick (C_BACK);
end;

procedure TFCalculator.AddBracket (cBracket: string);
// fgt der combobox die eingegebene klammer hinzu. sowhl
// die ffnende wie auch die schlieende
begin
  cmbCalcValues.Items.Add (format ('%s%s%s', [cBracket[1], C_DELIM, cBracket[2]]));
  cmbCalcValues.ItemIndex := cmbCalcValues.Items.Count - 1;
end;

procedure TFCalculator.AddCalcValue (cInputValue: string);
// fgt den aktuellen Term mit Operator und Vorzeichen zur
// combobox als item hinzu.
var
  nValue: double;
  cOper: char;
begin
  if cInputValue > '' then begin
    nValue := GetFloat(cInputValue);
    if cInputValue[2] = C_MINUS then begin
      nValue := nValue * (-1);
    end;
    cOper := cInputValue[1];
    if not (cOper in [C_MINUS, C_PLUS, C_DIV, C_MULT]) then begin
      cOper := C_PLUS;
    end;
    cmbCalcValues.Items.Add (format ('%s%s%20.2f', [cOper, C_DELIM, nValue]));
    cmbCalcValues.ItemIndex := cmbCalcValues.Items.Count - 1;
  end;
end;

procedure TFCalculator.ProcessClick(cChar: char);
var
  cExpr: string;
  lAdd : boolean;
  nLeft, nRight: integer;
const
  C_ERREXPRESSION = 'Formelfehler';
  C_ERRBRACKETS   = 'Falscher Klammerausdruck';
begin
  lAdd          := false;
  ActiveControl := edtResult;
  cExpr         := edtExpression.Text;
  if cChar in [C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9, C_0] then begin
    // zahlen drfen immer eingegeben werden
    edtExpression.Text := cExpr + cChar;
    gInputValue        := gInputValue + cChar;
  end else if (cChar = C_LEFTBRACKET) then begin
    // wurde noch nichts eingegeben, darf eine offene klammer erzeugt werden
    if cExpr = '' then begin
      AddBracket (C_PLUS+cChar);
      edtExpression.Text := cExpr + cChar;
      gInputValue        := '';
    end else begin
      // nach jedem der folgenden operatoren darf eine klammer geffnet werden:
      if (cExpr[length (cExpr)] in [C_DIV, C_MULT, C_PLUS, C_MINUS, C_LEFTBRACKET]) then begin
        AddBracket (cExpr[length (cExpr)]+cChar);
        edtExpression.Text := cExpr + cChar;
        gInputValue        := '';
      end;
    end;
  end else if (cChar = C_RIGHTBRACKET) then begin
    if cExpr <> '' then begin
      if (cExpr[length (cExpr)] in [C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9, C_0, C_DOT, C_RIGHTBRACKET]) then begin 
        nLeft  := GetOpenCnt (1, cExpr);
        nRight := GetCloseCnt (length (cExpr), cExpr);
        if nRight < nLeft then begin
          if not (cExpr[length (cExpr)] = C_RIGHTBRACKET) then begin
            AddCalcValue (gInputValue);
            gInputValue := '';
          end;
          AddBracket (' '+cChar);
          edtExpression.Text := cExpr + cChar;
          gInputValue        := '';
        end;
      end;
    end;
  end else if cChar in [C_MINUS, C_PLUS, C_DIV, C_MULT] then begin
    // wurde ein operator eingegeben, ist damit der vorhergehende term 
    // abgeschlossen. es muss berprft werden, ob der zur combobox hinzugefgt 
    // werden kann.
    if length (gInputValue) > 2 then begin
      // bei mehr als zwei zeichen immer. dann wurden der Operator, vielleicht 
      // ein vorzeichen und mindestens eine zahl eingegeben.
      AddCalcValue (gInputValue);
      gInputValue := '';
    end else if length (gInputValue) > 1 then begin
      // bei mehr als einem zeichen wird berprft, ob das letzte zeichen eine 
      // zahl war. ist das der fall ist der term abgeschlossen und kann ver-
      // arbeitet werden.
      if gInputValue[2] in [C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9, C_0] then begin
        AddCalcValue (gInputValue);
        gInputValue := '';
      end;
    end else if length (gInputValue) = 1 then begin
      // bei einem zeichen wird berprft, ob das letzte zeichen eine 
      // zahl war. ist das der fall ist der term abgeschlossen und kann ver-
      // arbeitet werden.
      if gInputValue[1] in [C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9, C_0] then begin
        AddCalcValue (gInputValue);
        gInputValue := '';
      end;
    end;
    if ((cExpr = '') and (cChar = C_MINUS)) then begin
      // '-' als erstes zeichen zulassen
      lAdd := true;
    end else if (cChar = C_MINUS) and (cExpr[length (cExpr)] in [C_DIV, C_MULT]) then begin
      // '-' zulassen, wenn vorher eine division oder multiplikation steht
      lAdd := true;
    end else if (cExpr <> '') and (not (cExpr[length (cExpr)] in [C_MINUS, C_PLUS, C_DIV, C_MULT])) then begin
      // operator imer zulassen, wenn vorher kein operator stand
      lAdd := true;
    end;
    if lAdd then begin
      edtExpression.Text := cExpr + cChar;
      gInputValue        := gInputValue + cChar;
    end;
  end else if uppercase(cChar) = uppercase(C_CLEAR) then begin
    // eingaben und ergebnis lschen
    ClearCalculator;
  end else if cChar = C_DOT then begin
    // dezimalpunkt nur zulassen, wenn fr die aktuelle zahl noch keiner eingegeben wurde
    if pos (C_DOT, gInputValue) = 0 then begin
      edtExpression.Text := cExpr + cChar;
      gInputValue        := gInputValue + cChar;
    end;
  end else if cChar = C_BACK then begin
    // maximal die letzte eingabe und den letzen oparator lschen
    if length (cExpr) > 0 then begin
      if (gInputValue > '') or 
         (cExpr[length (cExpr)] in [C_MINUS, C_PLUS, C_DIV, C_MULT, C_DOT]) then begin
        edtExpression.Text := copy (cExpr, 1, length (cExpr)-1);
        delete (gInputValue, length (gInputValue), 1);
      end;
    end;
  end else if (cChar = C_RESULT) then begin
    // ergebnis ausrechnen
    if cExpr <> '' then begin
      // mgliche angehangene operatoren entfernen
      DeleteTrailingOperatos (cExpr);
      edtExpression.Text := cExpr;
    end;
    
    // steht noch eine eingabe aus ?
    if (gInputValue > '') then begin
      AddCalcValue (gInputValue);
      gInputValue := '';
    end;

    // nur berechnen, wenn auch was eingegeben wurde  
    if cExpr <> '' then begin
      if CheckBrackets (cExpr) then begin
        edtResult.Text := FloatToStr (ParseAndCalculate (cExpr));
      end else begin
{$ifdef HaushaltWin}
        Fehler (C_ERRBRACKETS);
{$else}
        Messagebox (null, pchar(C_ERRBRACKETS), C_ERREXPRESSION, MB_OK+MB_ICONEXCLAMATION);
{$endif}
      end;
    end;
  end;
  ActiveControl := edtResult;
end;

function TFCalculator.GetFloat (cValue: string): double;
// holt die zahl aus dem aktuellen term. die fhrenden 
// Operatoren/Vorzeichen werden bersprungen
var
  i: integer;
begin
  while cValue[1] in [C_MINUS, C_PLUS, C_DIV, C_MULT] do begin
    delete (cValue, 1, 1);
  end;
  i := 1;
  while (i <= length (cValue)) and 
        (cValue[i] in [C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9, C_0, C_DOT]) do begin
    inc (i);
  end;
  if i <= length (cValue) then begin
    cValue := copy (cValue, 1, i-1);
  end;
  try
    result := StrToFloat (cValue);
  except
    result := 0.00000000000000000000001;
  end;
end;

function TFCalculator.GetPos (nStart: integer; cStr: string): integer;
// holt die position eines operators im string. dabei muss zwischen 
// vorzeichen ('-') und operator unterschieden werden. ein vorzeichen kann
// nach einem Multiplikations- bzw. Divisionsoperator stehen.
var
  i: integer;
begin
  result := 0;
  for i := nStart to length (cStr) do begin
    if cStr[i] in [C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9, C_0, C_DOT] then begin
      continue;
    end;
    // ist es ein minus und davor steht kein operator? dann ist dieses minus auch
    // ein operator.
    if (cStr[i] in [C_MINUS]) and (not (cStr[i-1] in [C_PLUS, C_DIV, C_MULT])) then begin
      result := i;
      exit;
    end;
    // die anderen operatoren sind einfach zu identifizieren:
    if cStr[i] in [C_PLUS, C_DIV, C_MULT, C_LEFTBRACKET, C_RIGHTBRACKET] then begin
      result := i;
      exit;
    end;
  end;
end;

function TFCalculator.CalculateFactor: double;
// berechnet die kleinste einheit des ausdrucks
begin
  if gExpression[gi] in [C_1, C_2, C_3, C_4, C_5, C_6, C_7, C_8, C_9, C_0, C_DOT] then begin
    result := GetFloat (copy (gExpression, gi));
    gi     := GetPos (gi, gExpression);
  end else if gExpression[gi] = C_LEFTBRACKET then begin
    inc (gi);
    result := CalculateExpression;
    if gExpression[gi] = C_RIGHTBRACKET then begin
      inc (gi);
    end;
  end else if gExpression[gi] = C_MINUS then begin
    inc (gi);
    result := -CalculateFactor;
  end else if gExpression[gi] = C_PLUS then begin
    inc (gi);
    result := CalculateFactor;
  end;
end;

function TFCalculator.CalculateTerm: double;
// berechnet eine multiplikation bzw. division
begin
  result := CalculateFactor;
  while (gi > 0) and (gi <= length (gExpression)) and (gExpression[gi] in [C_MULT, C_DIV]) do begin
    if gExpression[gi] = C_MULT then begin
      inc (gi);
      result := result * CalculateFactor;
    end else if gExpression[gi] = C_DIV then begin
      inc (gi);
      result := result / CalculateFactor;
    end;
  end;
end;

function TFCalculator.CalculateExpression: double;
// berechnet den ausdruck
begin
  result := CalculateTerm;
  while (gi > 0) and (gi <= length (gExpression)) and (gExpression[gi] in [C_PLUS, C_MINUS]) do begin
    if gExpression[gi] = C_PLUS then begin
      inc (gi);
      result := result + CalculateTerm;
    end else if gExpression[gi] = C_MINUS then begin
      inc (gi);
      result := result - CalculateTerm;
    end;
  end;
end;

function TFCalculator.ParseAndCalculate(cExpr: string): double;
begin
  result := 0;
  ActiveControl := edtResult;

  // fr die rekursive berechnung initialisieren
  gExpression   := edtExpression.Text;
  gi            := 1; 
  
  result        := CalculateExpression;
  ActiveControl := edtResult;
end;

procedure TFCalculator.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ActiveControl := edtResult;
  if (Key = 13) then begin
    btnResultClick (nil);
  end else if Key = 8 then begin
    btnBackClick (nil);
  end else if (Key = 188) or (Key = 110) then begin
    btnDotClick (nil);
  end else if (Key = 67) or (Key = VK_ESCAPE) then begin
    btnClearClick (nil);
  end else if (Key = 49) or (Key = 97) then begin
    btnOneClick (nil);
  end else if (Key = 50) or (Key = 98) then begin
    btnTwoClick (nil);
  end else if (Key = 51) or (Key = 99) then begin
    btnThreeClick (nil);
  end else if (Key = 52) or (Key = 100) then begin
    btnFourClick (nil);
  end else if (Key = 53) or (Key = 101) then begin
    btnFiveClick (nil);
  end else if (Key = 54) or (Key = 102) then begin
    btnSixClick (nil);
  end else if (Key = 103) then begin
    btnSevenClick (nil);
  end else if (Key = 55) then begin
    if ssShift in Shift then begin
      btnDivClick (nil);
    end else begin
      btnSevenClick (nil);
    end;
  end else if (Key = 56) then begin
    if ssShift in Shift then begin
      btnBracketsOpenClick (nil);
    end;
  end else if (Key = 57) then begin
    if ssShift in Shift then begin
      btnBracketsCloseClick (nil);
    end;
  end else if (Key = 56) or (Key = 104) then begin
    btnEightClick (nil);
  end else if (Key = 57) or (Key = 105) then begin
    btnNineClick (nil);
  end else if (Key = 48) or (Key = 96) then begin
    if ssShift in Shift then begin
      btnResultClick (nil);
    end else begin
      btnZeroClick (nil);
    end;
  end else if (Key = 189) or (Key = 109) then begin
    btnMinusClick (nil);
  end else if (Key = 111) then begin
    btnDivClick (nil);
  end else if (Key = 187) then begin
    if ssShift in Shift then begin
      btnMultClick (nil);
    end else begin
      btnPlusClick (nil);
    end;
  end else if (Key = 107) then begin
    btnPlusClick (nil);
  end else if (Key = 186) or (Key = 106) then begin
    btnMultClick (nil);
  end;
  ActiveControl := edtResult;
end;

procedure TFCalculator.CreateParams(var Params: TCreateParams);
(*
 URL: http://msdn.microsoft.com/en-us/library/61fe4bte(v=vs.71).aspx
 
	WS_EX_ACCEPTFILES   		Specifies that a window created with this style accepts 
 												drag-and-drop files.
	WS_EX_APPWINDOW   			Forces a top-level window onto the taskbar when the 
 												window is visible. 
	WS_EX_CLIENTEDGE   			Specifies that a window has a 3D look  that is, a 
 												border with a sunken edge.
	WS_EX_CONTEXTHELP   		Includes a question mark in the title bar of the 
 												window. When the user clicks the question mark, the 
                         cursor changes to a question mark with a pointer. If 
                         the user then clicks a child window, the child receives 
                         a WM_HELP message.
	WS_EX_CONTROLPARENT   	Allows the user to navigate among the child windows of 
 												the window by using the TAB key.
	WS_EX_DLGMODALFRAME   	Designates a window with a double border that may 
 												(optionally) be created with a title bar when you 
                         specify the WS_CAPTION style flag in the dwStyle 
                         parameter. 
	S_EX_LEFT   						Gives window generic left-aligned properties. This is 
 												the default.
	WS_EX_LEFTSCROLLBAR   	Places a vertical scroll bar to the left of the client 
 												area.
	WS_EX_LTRREADING   			Displays the window text using left-to-right reading 
 												order properties. This is the default.
	WS_EX_MDICHILD   				Creates an MDI child window.
	WS_EX_NOPARENTNOTIFY   	Specifies that a child window created with this style 
 												will not send the WM_PARENTNOTIFY message to its parent 
                         window when the child window is created or destroyed. 
	WS_EX_OVERLAPPEDWINDOW  Combines the WS_EX_CLIENTEDGE and WS_EX_WINDOWEDGE 
 												styles
	WS_EX_PALETTEWINDOW   	Combines the WS_EX_WINDOWEDGE and WS_EX_TOPMOST styles.
	WS_EX_RIGHT   					Gives a window generic right-aligned properties. This 
 												depends on the window class.
	WS_EX_RIGHTSCROLLBAR   	Places a vertical scroll bar (if present) to the right 
 												of the client area. This is the default.
	WS_EX_RTLREADING   			Displays the window text using right-to-left reading 
 												order properties.
	WS_EX_STATICEDGE   			Creates a window with a three-dimensional border style 
 												intended to be used for items that do not accept user 
                         input.
	WS_EX_TOOLWINDOW   			Creates a tool window, which is a window intended to 
 												be used as a floating toolbar. A tool window has a 
                         title bar that is shorter than a normal title bar, and 
                         the window title is drawn using a smaller font. A tool 
                         window does not appear in the task bar or in the window 
                         that appears when the user presses ALT+TAB.
	WS_EX_TOPMOST   				Specifies that a window created with this style should 
 												be placed above all nontopmost windows and stay above 
                         them even when the window is deactivated. An 
                         application can use the SetWindowPos member function 
                         to add or remove this attribute. 
	S_EX_TRANSPARENT   			Specifies that a window created with this style is to 
 												be transparent. That is, any windows that are beneath 
                         the window are not obscured by the window. A window 
                         created with this style receives WM_PAINT messages 
                         only after all sibling windows beneath it have been 
                         updated.
	WS_EX_WINDOWEDGE   			Specifies that a window has a border with a raised 
 												edge.
*)
begin
  inherited CreateParams(Params);
  with Params do begin
    // Form with a raised edge
    ExStyle := Params.ExStyle OR WS_EX_OVERLAPPEDWINDOW;
    // TaskBar button for every Delphi form
    ExStyle := ExStyle or WS_EX_APPWINDOW;
    // make form stay on top
    ExStyle := ExStyle or WS_EX_TOPMOST;
    // make form a child window
    // Style := Style or WS_CHILDWINDOW;
    // make form transparent
    // Params.ExStyle := Params.ExStyle or WS_EX_TRANSPARENT;
    // captionless form
    // Params.Style := Params.Style and not WS_CAPTION;
    WndParent := GetDesktopWindow;
    // WndParent := FBearbeitenWindow.Handle;
    // WndParent := Application.Handle;
  end;
end;

procedure TFCalculator.FormShow(Sender: TObject);
begin
  tbAlphaBlend.Position := FCalculator.AlphaBlendValue;
{$ifdef HaushaltWin}
  HaushaltUtility.RestoreFormState (FCalculator);
{$endif}  
end;

procedure TFCalculator.tbAlphaBlendChange(Sender: TObject);
begin
  FCalculator.AlphaBlendValue := FCalculator.tbAlphaBlend.Position;
end;

procedure TFCalculator.btnUpClick(Sender: TObject);
var
  cExpr: string;
begin
  if (edtExpression.Text <> '') and (edtResult.Text <> '') then begin
    cExpr              := edtResult.Text;
    ClearCalculator;
    edtExpression.Text := cExpr;
    gInputValue        := C_PLUS+cExpr;
    AddCalcValue (gInputValue);
    gInputValue         := '';
  end;
end;

procedure TFCalculator.ClearCalculator;
begin
  edtExpression.Text := '';
  edtResult.Text     := '0';
  gInputValue        := C_PLUS;
  cmbCalcValues.Items.Clear;
  cmbCalcValues.Text := '';
end;

procedure TFCalculator.btnUpLstClick(Sender: TObject);
var
  cWork, cExpr, cValue: string;
  posi: integer;
begin
  // mgliche angehangene operatoren entfernen
  DeleteTrailingOperatos (cExpr);
  
  if cmbCalcValues.ItemIndex > -1 then begin
    cExpr := edtExpression.Text;

    cWork  := cmbCalcValues.Items[cmbCalcValues.ItemIndex];
    posi   := pos (C_DELIM, cWork);
    cValue := cWork[1] + trim (copy (cWork, posi+length(C_DELIM), length (cWork)));

    AddCalcValue (cValue);
    
    edtExpression.Text := cExpr + cValue;
  end;
end;

procedure TFCalculator.DeleteTrailingOperatos (var cExpr: string);
var
  posi, oldIdx, i: integer;
  cValue, cWork: string;
begin
  while (length (cExpr) > 0) and 
        (cExpr[length(cExpr)] in [C_MINUS, C_PLUS, C_DIV, C_MULT, C_DOT, C_LEFTBRACKET]) do begin
    delete (cExpr, length(cExpr), 1);
    // mgliche angehangene operatoren entfernen
    if length (gInputValue) > 0 then begin
      delete (gInputValue, length (gInputValue), 1);
    end;
  end;
  oldIdx := cmbCalcValues.ItemIndex;
  for i := cmbCalcValues.Items.Count-1 downto 0 do begin
    posi   := pos (C_DELIM, cWork);
    cWork  := cmbCalcValues.Items[i];
    cValue := trim (copy (cWork, posi+length(C_DELIM), length (cWork)));
    if cValue[1] in [C_MINUS, C_PLUS, C_DIV, C_MULT, C_DOT, C_LEFTBRACKET] then begin
      cmbCalcValues.Items.Delete(i);
    end else begin
      break;
    end;
  end;
  // zeigte der itemindex der combobox in den gelschten bereich?
  if oldIdx > cmbCalcValues.Items.Count-1 then begin
    cmbCalcValues.ItemIndex := -1;
  end;
end;

procedure TFCalculator.itmTermLoeschenClick(Sender: TObject);
var
  posi, i: integer;
  cOper: char;
  cValue, cWork: string;
begin
  if cmbCalcValues.ItemIndex > -1 then begin
    // wenn es nicht der letzt ist oder der erste und der nachfolgende 
    // operator eine multiplikation oder division ankndigt, wird der 
    // nachfolgende operator gendert in addition oder subtraktion
    if (cmbCalcValues.ItemIndex = 0) and
       (cmbCalcValues.Items.Count > 1) then begin
      cWork := cmbCalcValues.Items[1];
      if cWork[1] = C_MULT then begin
        cWork[1] := C_PLUS;
        cmbCalcValues.Items[1] := cWork;
      end else if cWork[1] = C_DIV then begin
        cWork[1] := C_MINUS;
        cmbCalcValues.Items[1] := cWork;
      end;
    end else if (cmbCalcValues.ItemIndex > 0) and
                (cmbCalcValues.ItemIndex < cmbCalcValues.Items.Count-1) then begin
      cWork  := cmbCalcValues.Items[cmbCalcValues.ItemIndex-1];
      cValue := trim (copy (cWork, posi+length(C_DELIM)));
      if cValue[1] = C_LEFTBRACKET then begin
        cWork  := cmbCalcValues.Items[cmbCalcValues.ItemIndex+1];
        if cWork[1] = C_MULT then begin
          cWork[1] := C_PLUS;
          cmbCalcValues.Items[cmbCalcValues.ItemIndex+1] := cWork;
        end else if cValue[1] = C_DIV then begin
          cWork[1] := C_MINUS;
          cmbCalcValues.Items[cmbCalcValues.ItemIndex+1] := cWork;
        end;
      end;
    end;
    cmbCalcValues.Items.Delete(cmbCalcValues.ItemIndex);
    edtExpression.Text := '';
    if cmbCalcValues.Items.Count > 0 then begin
      for i := 0 to cmbCalcValues.Items.Count-1 do begin
        cWork  := cmbCalcValues.Items[i];
        posi   := pos (C_DELIM, cWork);
        cOper  := cWork[1];
        cValue := trim (copy (cWork, posi+length(C_DELIM)));
        if cValue[1] = C_LEFTBRACKET then begin
          edtExpression.Text := edtExpression.Text + cOper + cValue;
        end else if cValue[1] = C_RIGHTBRACKET then begin
          edtExpression.Text := edtExpression.Text + cValue;
        end else begin
          edtExpression.Text := edtExpression.Text + cOper + cValue
        end;
      end;
    end;
    gInputValue := '';
  end;
end;

function TFCalculator.CheckBrackets (cExpr: string): boolean;
var
  i, nLeft, nRight: integer;
begin
  nLeft  := GetOpenCnt (1, cExpr);
  nRight := GetCloseCnt (length (cExpr), cExpr);
  result := nLeft = nRight;
end;

function TFCalculator.GetOpenCnt (nStart: integer; cExpr: string): integer;
var 
  i: integer;
begin
  result := 0;
  for i := nStart to length (cExpr) do begin
    if cExpr[i] = C_LEFTBRACKET then begin
      inc (result);
    end;
  end;
end;

function TFCalculator.GetCloseCnt (nStart: integer; cExpr: string): integer;
var 
  i: integer;
begin
  result := 0;
  for i := nStart downto 1 do begin
    if cExpr[i] = C_RIGHTBRACKET then begin
      inc (result);
    end;
  end;
end;

procedure TFCalculator.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
{$ifdef HaushaltWin}
  HaushaltUtility.SaveFormState (FCalculator);
{$endif}  
  // damit das icon nicht aus der taskbar verschwindet nicht schlieen,
  // sondern nur minimieren
  self.WindowState := wsMinimized;
  CanClose := false;
end;

end.
